/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

import com.ibm.samplegallery.WebappResources;
import com.ibm.samplegallery.internal.*;
/**
 * Class defining defining the framesets used to show the content (right side).
 */
public class GalleryContentController extends HttpServlet implements GalleryConstants {
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	private void processRequest(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		LayoutData data = new LayoutData(req, resp);

		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		StringBuffer html = new StringBuffer();
		html.append("<html>\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n"); //$NON-NLS-1$
		// The below CSS segment formats the border around and between the content frames
		html.append("<style type=\"text/css\">\n" +
				"FRAMESET {\n" +
				"border-top:1px solid ThreeDShadow;\n" +
				"border-left:1px solid ThreeDShadow;\n" +
				"border-right:1px solid ThreeDShadow;\n" +
				"border-bottom:1px solid ThreeDShadow;\n" +
				"}\n" +
				"</style>\n");
		
		// The below script handles adjusting size of "Contents" header frame
		html.append("<script language=\"JavaScript\">\n" +
				"function onloadHandler(e)\n" +
				"{\n" +
				"var h=window.ContentToolbarFrame.document.getElementById(\"titleText\").offsetHeight;\n" +
				"if(h<=19){\n" +
				"return; \n" +
				"}\n" +
				"document.getElementById(\"contentFrameset\").setAttribute(\"rows\", (11+h)+\",*\"); \n" +
				"window.ContentToolbarFrame.document.getElementById(\"titleTextTableDiv\").style.height=(9+h)+\"px\"; \n" +
				"}\n" +
				"</script>\n");
		html.append("</head>\n"); //$NON-NLS-1$
		// The below line calls onloadHandler, the next line does not
		html.append("<frameset id=\"contentFrameset\" onload=\"onloadHandler()\" rows=\"24,*\" frameborder=\"0\" framespacing=\"0\" border=0 spacing=0>\n"); //$NON-NLS-1$
		//html.append("<frameset id=\"contentFrameset\" rows=\"24,*\" frameborder=\"0\" framespacing=\"0\" border=0 spacing=0>\n"); //$NON-NLS-1$
		html.append("<frame name=\"ContentToolbarFrame\" title=\"" + WebappResources.getString(I18N.GALLERY_FRAME_TOOLBAR) + "\" src='GalleryContentToolbar'  marginwidth=\"0\" marginheight=\"0\" scrolling=\"no\" frameborder=\"0\" noresize=0>\n"); //$NON-NLS-1$
		html.append("<frame name=\"Main\" title=\"" + WebappResources.getString(I18N.GALLERY_FRAME_MAIN) + "\" src='" + data.getContentURL() + "' marginwidth=\"10\" marginheight=\"0\" frameborder=\"0\" scrolling=\"auto\">\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("</frameset>\n"); //$NON-NLS-1$
		html.append("</html>\n"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
