/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.samplegallery.internal.GalleryConstants;
import com.ibm.samplegallery.internal.LayoutData;
import com.ibm.samplegallery.internal.View;

/**
 * Create the frames used in the navigator pane - tree view and bookmark frames.
 */
public class GalleryNavigatorController extends HttpServlet implements GalleryConstants {
	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		processRequest(req, res);
	}
	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		processRequest(req, res);
	}
	public void processRequest(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		LayoutData data = new LayoutData(req, resp);
		View[] views = data.getViews();
		StringBuffer html = new StringBuffer();
		html.append("<html>\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		html.append("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		
		html.append("<style type=\"text/css\">\n"); //$NON-NLS-1$
		html.append("HTML {\n"); //$NON-NLS-1$
		html.append("width:100%;\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("border:0px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("BODY {\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("IFRAME {\n"); //$NON-NLS-1$
		html.append("width:100%;\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".hidden {\n"); //$NON-NLS-1$
		html.append("visibility:hidden;\n"); //$NON-NLS-1$
		html.append("width:0;\n"); //$NON-NLS-1$
		html.append("height:0;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append(".visible {\n"); //$NON-NLS-1$
		html.append("visibility:visible;\n"); //$NON-NLS-1$
		html.append("width:100%;\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("</style>\n"); //$NON-NLS-1$
		html.append("<script language=\"Javascript\">\n"); //$NON-NLS-1$
		html.append("var lastView = \"\";\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("function showView(view)\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("if (view == lastView)\n"); //$NON-NLS-1$
		html.append("return;\n"); //$NON-NLS-1$
		html.append("lastView = view;\n"); //$NON-NLS-1$
		html.append("var iframes = parent.treeNav.document.body.getElementsByTagName(\"IFRAME\");\n"); //$NON-NLS-1$
		html.append("for (var i=0; i<iframes.length; i++)\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("if (iframes[i].id != view){\n"); //$NON-NLS-1$
		html.append("iframes[i].className = \"hidden\";\n"); //$NON-NLS-1$
		html.append("iframes[i].style.visibility=\"hidden\";\n"); //$NON-NLS-1$
		html.append("}else{\n"); //$NON-NLS-1$
		html.append("iframes[i].className = \"visible\";\n"); //$NON-NLS-1$
		html.append("iframes[i].style.visibility=\"visible\";\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("</script>\n"); //$NON-NLS-1$
		html.append("</head>\n"); //$NON-NLS-1$
		html.append("<body  tabIndex=\"-1\">\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		for (int i=0; i<views.length; i++) 	{
			String className = "visible";  //$NON-NLS-1$
			html.append("<iframe frameborder=\"0\"\n"); //$NON-NLS-1$
			html.append("class=\"" + className + "\"\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("name=\"" + views[i].getName() + "\"\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("id=\"" + views[i].getName() + "\"\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("src=\"" + views[i].getURL() + "\"\n"); //$NON-NLS-1$ //$NON-NLS-2$
			html.append("</iframe>\n"); //$NON-NLS-1$
			html.append("\n"); //$NON-NLS-1$
		}
		html.append("</body>\n"); //$NON-NLS-1$
		html.append("</html>\n"); //$NON-NLS-1$

		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
